#!/bin/sh

cp ../rickrack-s1.sqlite rickrack.sqlite
sqlite3 -header rickrack.sqlite "
    attach '../rickrack-s2.sqlite' as s2;
    pragma s2.journal_mode = delete;
    begin;
    insert into Timing
        select sn, 'session1', min(first_sent), max(received)
        from Timing
        group by sn;
    create temp table MatchingSNs as
        select main.MTurk.sn as sn1, s2.MTurk.sn as sn2
        from main.MTurk join s2.MTurk using (workerid)
        where main.MTurk.reconciled and s2.MTurk.reconciled;
    select * from MatchingSNs;
    insert into D
        select sn1 as sn, k, v
        from s2.D join MatchingSNs on sn = sn2;
    insert into Timing
        select sn1 as sn, k, first_sent, received
        from s2.Timing join MatchingSNs on sn = sn2;
    insert into Timing
        select sn1, 'session2', min(first_sent), max(received)
        from s2.Timing join MatchingSNs on sn = sn2
        group by sn;
    update Subjects set ip = 'DEIDENTIFIED';
    update MTurk set workerid = 'DEIDENTIFIED', assignmentid = 'DEIDENTIFIED';
    commit;
    vacuum;"
