big.study1.table = function(sb2)

   {assoc.continuous = function(sb2, vname)
       {y = sb2[[vname]]
        round(d = 3, sapply(qw(itf.patience, itb.disc, itm.disc), function(s)
           {d = sb2[paste0(s, c(".near.r1", ".far.r1"))]
            names(d) = qw(near, far)
            model = lm(y ~ near * far, d)
            summary(model)$r.squared}))}

    assoc.discrete = function(sb2, vname, modeltype, na.rm = F)
       {sbf = if (na.rm) sb2[!is.na(sb2[[vname]]),] else sb2
        y = sbf[[vname]]
        if (is.logical(y))
            y = num(y)
        round(digits = 3, sapply(qw(itf.patience, itb.disc, itm.disc), function(s)
           {d = sbf[paste0(s, c(".near.r1", ".far.r1"))]
            names(d) = qw(near, far)
            if (modeltype == "binary")
                   {model = glm(y ~ near * far, d,
                        family = binomial(link = "probit"))
                    ps = predict(model, type = "response")
                    ps = ifelse(y, 1 - ps, ps)
                    base = ifelse(y, 1 - mean(y), mean(y))
                    1 - sum(ps^2) / sum(base^2)}
                else # modeltype == "ordinal"
                   {model = polr(y ~ near * far, d, method = "probit")
                    ps = predict(model, type = "probs")
                    ps = sapply(1 : nrow(ps), function(i)
                        1 - ps[i, char(y[i])])
                    base = sapply(y, function(yv)
                        mean(y != yv))
                    1 - sum(ps^2) / sum(base^2)}}))}

    prederror.continuous = function(sb2)
       {f = function(vname, untransform)
           {y = sb2[[vname]]
            signif(d = 3, c(sd(untransform(y)),
                sapply(qw(itf.patience, itb.disc, itm.disc), function(s)
               {d = sb2[paste0(s, c(".near.r1", ".far.r1"))]
                names(d) = qw(near, far)
                pred = crossvalid(d, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
                   {model = lm(y ~ near * far, cbind(train.iv, y = train.dv))
                    predict(model, newdata = test.iv)})
                sqrt(mean( (untransform(pred) - untransform(y))^2 ))})))}
        m = data.frame(check.names = F,
            Exercise = f("exercise", function(v) exp(v) - 1),
            "Healthy meals" = f("healthy.meals", ilogit),
            Savings = f("savings", ilogit))
        m = rbind(m[1,], NA, m[-1,])
        row.names(m) = c("Baseline", "Predictive accuracy",
          paste0("     ", qw(Fixed, Bisection, Matching)))
        m}

    prederror.discrete = function(sb2)
       {f = function(vname, modeltype, na.rm = F)
           {sbf = if (na.rm) sb2[!is.na(sb2[[vname]]),] else sb2
            y = sbf[[vname]]
            if (is.logical(y))
                y = num(y)
            round(digits = 2, c(num(max(prop.table(table(y)))),
                sapply(qw(itf.patience, itb.disc, itm.disc), function(s)
               {d = sbf[paste0(s, c(".near.r1", ".far.r1"))]
                names(d) = qw(near, far)
                if (modeltype == "binary")
                   {pred = crossvalid(d, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
                       {model = glm(y ~ near * far, cbind(train.iv, y = train.dv),
                            family = binomial(link = "probit"))
                        predict(model, type = "response", newdata = test.iv)})
                    mean((pred >= .5) == y)}
                else # modeltype == "ordinal"
                   {pred = crossvalid(d, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
                       {model = polr(y ~ near * far, cbind(train.iv, y = train.dv),
                            method = "probit")
                        char(predict(model, type = "class", newdata = test.iv))})
                    mean(pred == char(y))}})))}
        m = data.frame(check.names = F,
            Overweight = f("bmi", "binary"),
            "Tobacco use" = f("tobacco", "binary"),
            Gambling = f("gambling", "binary"),
            Flossing = f("floss", "ordinal"),
            "CC late fees" = f("cc.latefees", "binary", na.rm = T),
            "CC subpayment" = f("cc.subpay", "binary", na.rm = T))
        m = rbind(m[1,], NA, m[-1,])
        row.names(m) = c("Baseline", "Predictive accuracy",
          paste0("     ", qw(Fixed, Bisection, Matching)))
        m}

    m = data.frame(check.names = F,
        Exercise = assoc.continuous(sb2, "exercise"),
        "Healthy meals" = assoc.continuous(sb2, "healthy.meals"),
        Savings = assoc.continuous(sb2, "savings"),
        Overweight = assoc.discrete(sb2, "bmi", "binary"),
        "Tobacco use" = assoc.discrete(sb2, "tobacco", "binary"),
        Gambling = assoc.discrete(sb2, "gambling", "binary"),
        Flossing = assoc.discrete(sb2, "floss", "ordinal"),
        "CC late fees" = assoc.discrete(sb2, "cc.latefees", "binary", na.rm = T),
        "CC subpayment" = assoc.discrete(sb2, "cc.subpay", "binary", na.rm = T))
    m = rbind(NA, m)
    row.names(m) = c("Association",
      paste0("     ", qw(Fixed, Bisection, Matching)))
    m2 = cbind(prederror.continuous(sb2), prederror.discrete(sb2))
    rbind(m, m2)}

holm.bonferroni.superscripts = function(df)
   {alpha = .05
    mp.o = df$month.pvalue
    mp.c = p.adjust(mp.o, method = "holm")
    yp.o = df$year.pvalue
    yp.c = p.adjust(yp.o, method = "holm")
    sapply(seq_along(mp.o), function(i)
        {superscript = paste(collapse = ", ", c(
           (if (mp.c[i] < alpha) "mm" else
               (if (mp.o[i] < alpha) "m" else c())),
           (if (yp.c[i] < alpha) "yy" else
               (if (yp.o[i] < alpha) "y" else c()))))
         if (superscript != "")
             superscript = paste0("^{", superscript, "}")
         superscript})}
