
ags = function(f, lo, hi, n.samples = 100)
   {m = matrix(ncol = 2, nrow = 0, dimnames = list(c(), c("x", "y")))
    # Begin by getting the endpoints and the midpoint.
    m = rbind(m,
        c(lo, f(lo)),
        c((lo + hi)/2, f((lo + hi)/2)),
        c(hi, f(hi)))
    # For each of the remaining samples, choose a point between
    # two existing samples.
    for (n in (nrow(m) + 1) : n.samples)
       {# Find the two samples with the greatest difference
        # between them (in terms of area).
        i = which.max(abs(diff(m[, "y"]) * diff(m[, "x"])))
          # Arguably, we should break ties randomly here
          # (instead of leftmost-first, as which.max does).
          # This would improve handling of, for example,
          # the uniform distribution. But perhaps this won't
          # matter in practice.
        # Use the midpoint as the next sample.
        mid = (m[i, "x"] + m[i + 1, "x"])/2
        m = rbind(
            m[1:i,],
            c(mid, f(mid)),
            m[(i+1) : nrow(m),])}
    m}

ags.mean = function(m)
   {weights = tail(m[, "y"], -1) * diff(m[, "x"])
    sum(tail(m[, "x"], -1) * weights) / sum(weights)}
